package cn.iocoder.yudao.module.shipment.service.boxPkgOrder;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.log.Log;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.order.dal.dataobject.order.OrderDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderItem.OrderItemDO;
import cn.iocoder.yudao.module.order.enums.ErrorCodeConstants;
import cn.iocoder.yudao.module.order.service.order.OrderItemService;
import cn.iocoder.yudao.module.order.service.order.OrderService;
import cn.iocoder.yudao.module.shipment.convert.BoxPkgOrderConvert;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxMergePkgDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxPkgOrderDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxPreloadGoodsDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxOrderCheckInfo.BoxOrderCheckInfoDO;
import cn.iocoder.yudao.module.shipment.dal.mysql.BoxPkgOrderMapper;
import cn.iocoder.yudao.module.shipment.dal.mysql.BoxPreloadGoodsMapper;
import cn.iocoder.yudao.module.shipment.dal.mysql.boxOrderCheckInfo.BoxOrderCheckInfoMapper;
import cn.iocoder.yudao.module.shipment.enums.AirShipmentStatusEnum;
import cn.iocoder.yudao.module.shipment.enums.MergePkgStatusEnum;
import cn.iocoder.yudao.module.shipment.enums.OrderShipmentLog;
import cn.iocoder.yudao.module.shipment.service.box.BoxService;
import cn.iocoder.yudao.module.shipment.service.boxMergePkg.BoxMergePkgService;
import cn.iocoder.yudao.module.shipment.service.boxOrderCheckInfo.BoxOrderCheckInfoService;
import cn.iocoder.yudao.module.shipment.service.boxPreloadGoods.BoxPreloadGoodsService;
import cn.iocoder.yudao.module.shipment.vo.boxOrderCheckInfo.BoxOrderCheckInfoCreateReqVO;
import cn.iocoder.yudao.module.shipment.vo.boxPkgOrder.BoxPkgOrderCreateReqVO;
import cn.iocoder.yudao.module.shipment.vo.boxPkgOrder.BoxPkgOrderQueryVO;
import cn.iocoder.yudao.module.shipment.vo.boxPkgOrder.BoxPkgOrderScanCodeVO;
import cn.iocoder.yudao.module.shipment.vo.boxPkgOrder.BoxPkgOrderUpdateReqVO;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.order.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.module.shipment.enums.ErrorCodeConstants.*;

/**
 * 合包订单 Service 实现类
 *
 * @author 江楠
 */
@Service
@Validated
public class BoxPkgOrderServiceImpl extends AbstractService<BoxPkgOrderMapper, BoxPkgOrderDO> implements BoxPkgOrderService {

    @Resource
    private BoxPkgOrderMapper boxPkgOrderMapper;

    @Resource
    private OrderItemService orderItemService;

    @Resource
    private BoxMergePkgService boxMergePkgService;

    @Resource
    @Lazy
    private BoxService boxService;

    @Resource
    @Lazy
    private BoxOrderCheckInfoService boxOrderCheckInfoService;

    @Resource

    private OrderService orderService ;

    @Resource
    private BoxPreloadGoodsMapper boxPreloadGoodsMapper  ;

    @Resource
    private BoxOrderCheckInfoMapper boxOrderCheckInfoMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String createBoxPkgOrder(BoxPkgOrderCreateReqVO createReqVO) {
        create(createReqVO);
        // 返回
        return "success";
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public String scanOrderNoCreate(BoxPkgOrderScanCodeVO createReqVO){
        BoxPkgOrderCreateReqVO vo = new BoxPkgOrderCreateReqVO();

        String orderNumCode = createReqVO.getOrderNo();
        int position = orderNumCode.lastIndexOf("-");
        if(position >= 0) {

            if(orderNumCode.contains("A") && orderNumCode.startsWith("A")){

                return   this.scanCodeByOrderNo(orderNumCode,vo,createReqVO);
            }


        }else if(!createReqVO.getOrderNo().contains("-")){
            BoxMergePkgDO boxMergePkgDO = boxMergePkgService.selectOne(new LambdaQueryWrapper<BoxMergePkgDO>()
                    .eq(BoxMergePkgDO::getShipmentId, createReqVO.getShipmentId())
                    .eq(BoxMergePkgDO::getPkgNum, orderNumCode));
            OrderDO  orderDO = orderService.getOne(new LambdaQueryWrapperX<OrderDO>().eq(OrderDO::getOrderNo,createReqVO.getOrderNo())) ;
              if(Objects.isNull(orderDO)){
                  throw  exception(ORDER_NOT_IN_BOX);
              }
                List<BoxPreloadGoodsDO> goodsDOS = boxPreloadGoodsMapper.selectList(new LambdaQueryWrapperX<BoxPreloadGoodsDO>().eq(BoxPreloadGoodsDO::getOrderId,orderDO.getOrderId()).eq(BoxPreloadGoodsDO::getDeleted,0));
                if (CollectionUtil.isNotEmpty(goodsDOS)) {
                    List<Long> orderIds = goodsDOS.stream().map(BoxPreloadGoodsDO::getOrderId).collect(Collectors.toList());
                    List<OrderDO> orderDOS = orderService.selectList(OrderDO::getOrderId, orderIds);
                    if(CollectionUtil.isNotEmpty(orderDOS)){
                        orderDOS.forEach(order->{
                            BoxPkgOrderCreateReqVO boxPkgOrderCreateReqVO = new BoxPkgOrderCreateReqVO();
                            boxPkgOrderCreateReqVO.setOrderId(order.getOrderId());
                            boxPkgOrderCreateReqVO.setPkgId(boxMergePkgDO.getId());
                            this.create(boxPkgOrderCreateReqVO);

                            Long orderId = order.getOrderId();

                            //找到这个订单所有需要装柜的编号
                            List<String> tagList = boxOrderCheckInfoService.getOrderTagList(order);
                            List<BoxOrderCheckInfoDO> boxOrderCheckInfoDOS = new ArrayList<>();
                            for (int i = 0; i < tagList.size(); i++) {
                                String tag = tagList.get(i);
                                BoxOrderCheckInfoDO boxOrderCheckInfoDO = new BoxOrderCheckInfoDO();
                                boxOrderCheckInfoDO.setOrderId(orderId);
                                boxOrderCheckInfoDO.setPkgId(boxMergePkgDO.getId());
                                boxOrderCheckInfoDO.setOrderNumCode(tag);
                                boxOrderCheckInfoDO.setShipmentId(createReqVO.getShipmentId());
                                boxOrderCheckInfoDO.setType(1);
                                boxOrderCheckInfoDO.setDeleted(false);
                                boxOrderCheckInfoDOS.add(boxOrderCheckInfoDO);
                            }
                            boxOrderCheckInfoService.saveBatch(boxOrderCheckInfoDOS);
                        });

                    }
                }else{
                    throw exception(ORDER_CASE_NUM_NOT_EXIST);
                }


        }

        // 返回
        return "success";
    }

    private String scanCodeByOrderNo(String orderNumCode ,BoxPkgOrderCreateReqVO vo, BoxPkgOrderScanCodeVO createReqVO){
        int position = orderNumCode.lastIndexOf("-");
          String orderNumber = orderNumCode.substring(0, position);
            Long orderId = orderService.getOrderIdByOrderNo(orderNumber);
            if(Objects.isNull(orderId)){
                throw  exception(ORDER_NOT_IN_BOX);
            }
            OrderDO order = orderService.getById(orderId);
            vo.setOrderId(orderId);

            List<BoxOrderCheckInfoDO>   tags = boxOrderCheckInfoService.getOrderTagNumList(order);
            if(CollectionUtil.isNotEmpty(tags)){
             List<BoxOrderCheckInfoDO> orderNum =   tags.stream().filter(t-> t.getOrderNumCode().equals(orderNumCode) || t.getOrderNumCode()==orderNumCode).collect(Collectors.toList());
             if(CollectionUtil.isEmpty(orderNum)){
                 throw  exception(ORDER_NOT_EXISTS);
             }

            }

            BoxMergePkgDO boxMergePkgDO =
                    boxMergePkgService.selectOne(new LambdaQueryWrapperX<BoxMergePkgDO>().eq(BoxMergePkgDO::getPkgNum,createReqVO.getPkgNum()));
            vo.setPkgId(boxMergePkgDO.getId()) ;
            List<BoxPkgOrderDO> pkgOrderDO =  boxPkgOrderMapper.selectList(new LambdaQueryWrapperX<BoxPkgOrderDO>().eq(BoxPkgOrderDO::getOrderId,orderId).eq(BoxPkgOrderDO::getPkgId,boxMergePkgDO.getId()));
            if(vo.getOrderId()!=null && vo.getPkgId()!=null){//订单和包裹id 不为空，调用装箱方法
                if(CollectionUtil.isEmpty(pkgOrderDO)){
                    this.create(vo);
                }


                //找到这个订单所有需要装柜的编号
                List<String> tagList = boxOrderCheckInfoService.getOrderTagList(order);
                List<BoxOrderCheckInfoDO> boxOrderCheckInfoDOS = new ArrayList<>();
                boolean ischeck = false;
                if(tagList.contains(orderNumCode) ){
                    String tag = orderNumCode ;
                    BoxOrderCheckInfoDO boxOrderCheckInfoDO = new BoxOrderCheckInfoDO();
                    boxOrderCheckInfoDO.setOrderId(orderId);
                    boxOrderCheckInfoDO.setPkgId(boxMergePkgDO.getId());
                    boxOrderCheckInfoDO.setOrderNumCode(tag);
                    boxOrderCheckInfoDO.setShipmentId(createReqVO.getShipmentId());
                    boxOrderCheckInfoDO.setType(1);
                    boxOrderCheckInfoDO.setDeleted(false);
                    boxOrderCheckInfoDOS.add(boxOrderCheckInfoDO);

                    List<BoxOrderCheckInfoDO>  checkInfoDO = boxOrderCheckInfoService.selectList(new LambdaQueryWrapper<BoxOrderCheckInfoDO>()
                            .eq(BoxOrderCheckInfoDO::getOrderNumCode,tag)
                            .eq(BoxOrderCheckInfoDO::getOrderId,orderId)
                            .eq(BoxOrderCheckInfoDO::getPkgId,boxMergePkgDO.getId())
                            .eq(BoxOrderCheckInfoDO::getShipmentId,createReqVO.getShipmentId()).eq(BoxOrderCheckInfoDO::getDeleted,0));
                    if(CollectionUtil.isNotEmpty(checkInfoDO)){
                        //已经存在这样的数据了
                        ischeck = true ;
                    }
                }

                if(!ischeck){
                    boxOrderCheckInfoService.saveBatch(boxOrderCheckInfoDOS);
                }else{
                    throw exception(ORDER_IS_PRE_INSTALLED);
                }

            }
            return "success" ;
    }


    private void create(BoxPkgOrderCreateReqVO createReqVO) {
        BoxDO boxDO = checkMergePkgStatus(createReqVO.getPkgId());
        // 这里添加合包装箱时，需要检查订单是否为该出货单下的预装订单
        long count = boxPreloadGoodsMapper.selectCount(new LambdaQueryWrapper<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getOrderId, createReqVO.getOrderId())
                .eq(BoxPreloadGoodsDO::getShipmentId, boxDO.getId()));
        if (count == 0){
            // 订单未预装，不能合包
            throw exception(ORDER_IS_NOT_PRE_INSTALLED);
        }
        List<OrderItemDO> orderItemDOS = orderItemService.selectList(OrderItemDO::getOrderId, createReqVO.getOrderId());
        orderItemDOS.stream().forEach(item -> {
            // 插入
            BoxPkgOrderDO boxPkgOrder = BoxPkgOrderConvert.INSTANCE.convert(createReqVO);
            boxPkgOrder.setOrderItemId(item.getOrderItemId());
            List<BoxPkgOrderDO> check = boxPkgOrderMapper.selectList(new LambdaQueryWrapper<BoxPkgOrderDO>().eq(BoxPkgOrderDO::getOrderId,item.getOrderId()).eq(BoxPkgOrderDO::getOrderItemId,item.getOrderItemId()).eq(BoxPkgOrderDO::getPkgId,createReqVO.getPkgId())) ;
            if(CollectionUtil.isEmpty(check)){
                boxPkgOrderMapper.insert(boxPkgOrder);
            }

        });
        Long aLong = boxPkgOrderMapper.selectCount(BoxPkgOrderDO::getPkgId, createReqVO.getPkgId());
        if (aLong.longValue() > 0L) {
            boxMergePkgService.update(new LambdaUpdateWrapper<BoxMergePkgDO>().set(BoxMergePkgDO::getStatus,2).eq(BoxMergePkgDO::getId,createReqVO.getPkgId()));
        }
        boxService.addOrderLog(Collections.singletonList(createReqVO.getOrderId()), OrderShipmentLog.MERGE_PKG_ADD, "");
    }



    @Override
    public void updateBoxPkgOrder(BoxPkgOrderUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateBoxPkgOrderExists(updateReqVO.getId());
        // 更新
        BoxPkgOrderDO updateObj = BoxPkgOrderConvert.INSTANCE.convert(updateReqVO);
        boxPkgOrderMapper.updateById(updateObj);
    }

    @Override
    public void deleteBoxPkgOrder(Long id) {
        // 校验存在
        this.validateBoxPkgOrderExists(id);
        // 删除
        boxPkgOrderMapper.deleteById(id);
    }

    private void validateBoxPkgOrderExists(Long id) {
        if (boxPkgOrderMapper.selectById(id) == null) {
            throw exception(BOX_PKG_ORDER_NOT_EXISTS);
        }
    }

    @Override
    public BoxPkgOrderDO getBoxPkgOrder(Long id) {
        return boxPkgOrderMapper.selectById(id);
    }

    @Override
    public List<BoxPkgOrderDO> getBoxPkgOrderList(Collection<Long> ids) {
        return boxPkgOrderMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<BoxPkgOrderDO> getBoxPkgOrderPage(BoxPkgOrderQueryVO query, PageVO page) {
        return boxPkgOrderMapper.selectPage(page, query);
    }

    @Override
    public List<BoxPkgOrderDO> getBoxPkgOrderList(BoxPkgOrderQueryVO query) {
        return boxPkgOrderMapper.selectList(query);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String createBatch(List<BoxPkgOrderCreateReqVO> createReqVO) {
        if (CollectionUtil.isNotEmpty(createReqVO)) {
            createReqVO.stream().forEach(item ->{
                create(item);
            });
        }
        return "success";
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deleteRelate(Long pkgId, Long orderId) {
        checkMergePkgStatus(pkgId);
        boxPkgOrderMapper.delete(new LambdaQueryWrapperX<BoxPkgOrderDO>().eq(BoxPkgOrderDO::getPkgId,pkgId).eq(BoxPkgOrderDO::getOrderId,orderId));
        boxOrderCheckInfoService.remove(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                .eq(BoxOrderCheckInfoDO::getOrderId,orderId)
                .eq(BoxOrderCheckInfoDO::getType,1)
        );
        Long aLong = boxPkgOrderMapper.selectCount(BoxPkgOrderDO::getPkgId, pkgId);
        if (aLong.longValue() <= 0L) {
            boxMergePkgService.update(new LambdaUpdateWrapper<BoxMergePkgDO>().set(BoxMergePkgDO::getStatus,1).eq(BoxMergePkgDO::getId,pkgId));
            boxService.addOrderLog(Collections.singletonList(orderId), OrderShipmentLog.MERGE_PKG_REMOVE, "");
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deleteBatchRelate(List<BoxPkgOrderQueryVO> list) {
        if (CollectionUtil.isNotEmpty(list)) {
            checkMergePkgStatus(list.get(0).getPkgId());
            List<Long> orderIdList = list.stream()
                    .map(BoxPkgOrderQueryVO::getOrderId)
                    .collect(Collectors.toList());
            boxService.addOrderLog(orderIdList, OrderShipmentLog.MERGE_PKG_REMOVE, "");
            list.stream().forEach(item -> {
                boxPkgOrderMapper.delete(new LambdaQueryWrapperX<BoxPkgOrderDO>().eq(BoxPkgOrderDO::getPkgId,item.getPkgId()).eq(BoxPkgOrderDO::getOrderId,item.getOrderId()));
                boxOrderCheckInfoService.remove(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                        .eq(BoxOrderCheckInfoDO::getOrderId,item.getOrderId())
                        .eq(BoxOrderCheckInfoDO::getType,1)
                );
            });
            Long aLong = boxPkgOrderMapper.selectCount(BoxPkgOrderDO::getPkgId, list.get(0).getPkgId());
            if (aLong.longValue() <= 0L) {
                boxMergePkgService.update(new LambdaUpdateWrapper<BoxMergePkgDO>().set(BoxMergePkgDO::getStatus,1).eq(BoxMergePkgDO::getId,list.get(0).getPkgId()));
            }
        }
    }

    @Override
    public void deleteRelateByOrderIds(Long shipmentId, List<Long> orderIds) {
        List<BoxMergePkgDO> boxMergePkgDOS = boxMergePkgService.selectList(BoxMergePkgDO::getShipmentId, shipmentId);
        List<Long> pkgIds = boxMergePkgDOS.stream().map(BoxMergePkgDO::getId).collect(Collectors.toList());
        if (CollectionUtil.isNotEmpty(pkgIds) && CollectionUtil.isNotEmpty(orderIds)) {
            boxPkgOrderMapper.delete(new LambdaQueryWrapperX<BoxPkgOrderDO>().in(BoxPkgOrderDO::getPkgId,pkgIds).in(BoxPkgOrderDO::getOrderId,orderIds));
        }
    }

    @Override
    public Map<String, Integer> getMergeOrderQualityByPkgIds(List<Long> pkgIds) {
        List<BoxMergePkgDO> mergeOrderQualityByPkgIds = boxPkgOrderMapper.getMergeOrderQualityByPkgIds(pkgIds);
        Map<String,Integer> map = new HashMap<>();
        mergeOrderQualityByPkgIds.stream().forEach(item -> {
            map.put(String.valueOf(item.getId()),item.getSumNum().intValue());
        });
        return map;
    }

    private BoxDO checkMergePkgStatus(Long pkgId) {
        BoxMergePkgDO boxMergePkgDO = boxMergePkgService.selectOne(BoxMergePkgDO::getId, pkgId);
        BoxDO box = boxService.getBox(boxMergePkgDO.getShipmentId());
        if (box.getAirShipmentStatus() != AirShipmentStatusEnum.UNSHIPMENT.getStatus()) {
            throw exception(MERGE_PKG_IS_FINISH);
        }
        return box;
    }
}
